import java.util.Scanner;

class FinnIterativt {
  // Konstant som brukes til  signalisere at et tall ikke finnes i tabellen.
  static final int FINNES_IKKE = -1;

  public static void main(String[] args) {
    // Tabell med alle primtallene mellom 1 og 100 i sortert rekkeflge:
    int[] primtall = { 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41,
        43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97 };

    System.out.print("Skriv heltall mellom 1 og 100: ");
    Scanner tastatur = new Scanner(System.in);
    int tall = tastatur.nextInt();
    if ((tall<1) || (tall>100)) {
      System.out.println("Tallet var ikke mellom 1 og 100");
      return;
    }

    int primtallIndex = finn(primtall, tall);
    if (primtallIndex == FINNES_IKKE) {
      System.out.println(tall + " er ikke et primtall");
    } else {
      System.out.println(tall + " er primtall nummer " +
          (primtallIndex + 1));
    }
  }

  static int finn(int[] sortertTabell, int ml) {
    return binrsk(sortertTabell, ml, 0, sortertTabell.length - 1);
  }

  static int binrsk(int[] sortertTabell, int ml, int nedre, int vre) {
    if (nedre > vre) {
      /* basistilfelle, parameterene spesifiserer et tomt tabell segment,
       dvs. at mlet ikke finnes i tabellen. */
      return FINNES_IKKE;
    }

    int midten = (nedre + vre)/2;
    int midtersteTall = sortertTabell[midten];

    System.out.println("*** nedre="+nedre+", midten="+midten+", vre="+vre);
    for (int i=nedre; i<=vre; i++)
      System.out.println(i + ": " + sortertTabell[i]);

    if (ml == midtersteTall) {
      // Enda et basistilfelle. Mlet ble funnet.
      return midten;
    }

    // Generelt tilfelle: sk enten i nedre eller vre tabellsegment.
    if (ml < midtersteTall) {
      return binrsk(sortertTabell, ml, nedre, midten-1);
    } else {
      return binrsk(sortertTabell, ml, midten+1, vre);
    }
  }
}