import java.util.Scanner;

//FinnRekursivt.java -- Rekursivt binrsk etter primtall
public class FinnRekursivt {
  // Konstant som signaliserer at et tall ikke finnes i tabellen.
  static final int FINNES_IKKE = -1;

  public static void main(String[] args) {
    // Tabell med primtallene mellom 1 og 100 i sortert rekkeflge:
    int[] primtall = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41,
        43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97};

    System.out.print("Skriv heltall mellom 1 og 100: ");
    Scanner tastatur = new Scanner(System.in);
    int tall = tastatur.nextInt();
    if ((tall<1) || (tall>100)) {
      System.out.println("Tallet var ikke mellom 1 og 100");
      return;
    }

    int primtallIndex = finn(primtall, tall);
    if (primtallIndex == FINNES_IKKE) {
      System.out.println(tall + " er ikke et primtall");
    } else {
      System.out.println(tall + " er primtall nummer " +
          (primtallIndex + 1));
    }
  }

  static int finn(int[] sortertTabell, int nkkel) {
    return binrsk(sortertTabell, nkkel, 0, sortertTabell.length - 1);
  }

  static int binrsk(int[] sortertTabell, int ml, int nedre, int vre) {
    if (nedre > vre) {
      return FINNES_IKKE; // basistilfelle, tom tabell
    }

    int midten = (nedre + vre)/2;
    int midtersteTall = sortertTabell[midten];

    if (ml == midtersteTall) {
      return midten; // Enda et basistilfelle. Mlet ble funnet.
    }

    // Generelt tilfelle: sk i enten nedre eller vre tabellsegment.
    if (ml < midtersteTall) {
      return binrsk(sortertTabell, ml, nedre, midten-1);
    } else {
      return binrsk(sortertTabell, ml, midten+1, vre);
    }
  }
}
