//Quicksort.java -- Rekursiv sorteringsalgoritme
public class Quicksort {
  public static void main(String[] args) {
    String[] ord = {
        "gul", "dom", "lit", "obs", "hos", "duo", "loe", "hva", "tog",
        "kur", "rom", "alt", "ham", "lav", "fot", "dyd", "ake", "dun",
        "gud", "elg", "tau", "vet", "ulv", "gnu", "egg", "kne", "pil",
        "dal", "syk", "lot", "nes", "buk", "hei", "lam", "lar", "ond",
        "for", "sky", "noe", "hov", "id", "ski", "fut", "kna", "var"
    };

    sorter(ord);

    for (int i=0; i<ord.length; i++)
      System.out.println(ord[i]);
  }

  static <T extends Comparable<T>> void sorter(T[] alleElementer) {
    quicksort(alleElementer, 0, alleElementer.length - 1);
  }

  static <T extends Comparable<T>> void quicksort(T[] elementer, int frste, int siste) {

    /* Basistilfelle: Null eller et element, ingen sortering ndvendig. */
    if (frste >= siste) {
      return;
    }

    // Generelt tilfelle: Partisjoner segmentet.
    int skillePosisjon = partisjoner(elementer, frste, siste);

    // Sorter elementene som var mindre eller lik skilleelementet:
    quicksort(elementer, frste, skillePosisjon-1);

    // Sorter elementene som var strre enn skilleelementet:
    quicksort(elementer, skillePosisjon+1, siste);
  }

  static <T extends Comparable<T>> int partisjoner(T[] elementer, int frste, int siste) {
    /* Generelt tilfelle: Del opp elementene i dem som er mindre
     eller lik skilleelementet, og dem som er strre enn skilleelementet. */
    T skilleElement = elementer[frste];
    int sisteLite = frste;
    int sisteUdelte = siste;

    // Utfr s lenge det er flere elementer som ikke har blitt delt.
    while (sisteLite < sisteUdelte) {
      int frsteUdelte = sisteLite + 1;
      T testElement = elementer[frsteUdelte];
      boolean strre = testElement.compareTo(skilleElement) > 0;
      if (strre) {
        // Bytt om for  plassere elementet etter de udelte.
        elementer[frsteUdelte] = elementer[sisteUdelte];
        elementer[sisteUdelte] = testElement;
        --sisteUdelte;
      } else {
        // Elementet er p riktig side av de udelte allerede.
        ++sisteLite;
      }
    }

    /* Ingen udelte igjen. Plassr skilleelementet mellom de store og
     sm elementene ved  bytte plass med det siste av de sm. */
    int skillePosisjon = sisteLite;
    elementer[frste] = elementer[skillePosisjon];
    elementer[skillePosisjon] = skilleElement;
    return skillePosisjon;
  }
}