//QuicksortPrint2.java - Rekursiv sorteringsalgoritme
public class QuicksortPrint2 {
  public static void main(String[] args) {
    String[] elementer = {
        "hei", "syk", "lot", "dal", "nes", "buk",  "lam"
//      10, 23, 19, 5, 8, 3, 2
//      10, 10, 19, 10, 10, 3,10
    };
    sorter(elementer);
  }

  static <T extends Comparable<T>> void sorter(T[] alleElementer) {
    skrivSegment("Tabell usortert: ", alleElementer, 0, alleElementer.length-1);
    quicksort(alleElementer, 0, alleElementer.length - 1, 1);
    skrivSegment("Tabell sortert: ", alleElementer, 0, alleElementer.length-1);
  }

  static <T extends Comparable<T>> void quicksort(T[] elementer, int frste, int siste, int niv) {

    // Basistilfelle: 0 eller ett element, ingen sortering ndvendig.
    if (frste >= siste) {
      System.out.println(blanker(niv) + niv + "> basistilfelle");
      return;
    }

    skrivSegment(blanker(niv) + niv + "> segment fr deling: ", elementer, frste, siste);

    //  Partisjonering
    int nedreIndeks = frste, vreIndeks = siste;
    T skilleelement = elementer[(frste+siste)/2];
    System.out.println(blanker(niv) + niv + "> skilleelementet: " + skilleelement);
    do {
      // Finn index til element som er strre eller lik skilleelement fra den ene siden.
      while (elementer[nedreIndeks].compareTo(skilleelement) < 0) nedreIndeks++;

      // Finn indeks til element som er mindre eller lik skilleelement fra den andre siden.
      while (elementer[vreIndeks].compareTo(skilleelement) > 0) vreIndeks--;

      // Bytt elementer hvis ndvendig.
      if (nedreIndeks <= vreIndeks) {
        T t = elementer[nedreIndeks];
        elementer[nedreIndeks] = elementer[vreIndeks];
        elementer[vreIndeks] = t;
        // Oppdater indeksene.
        nedreIndeks++; vreIndeks--;
      }
    } while (nedreIndeks <= vreIndeks);
    assert nedreIndeks > vreIndeks;
    skrivSegment(blanker(niv) + niv + "> segment etter deling: ", elementer, frste, siste);

    //  Generelle tilfeller
//  if (frste<vreIndeks)
    {
      skrivSegment(blanker(niv) + niv + "> segment fr sortering: ", elementer, frste, vreIndeks);
      quicksort(elementer, frste, vreIndeks, niv+1);
      skrivSegment(blanker(niv) + niv + "> segment etter sortering: ", elementer, frste, vreIndeks);
    }
//  if (nedreIndeks<siste)
    {
      skrivSegment(blanker(niv) + niv + "> segment fr sortering: ", elementer, nedreIndeks, siste);
      quicksort(elementer, nedreIndeks, siste, niv+1);
      skrivSegment(blanker(niv) + niv + "> segment etter sortering: ", elementer, nedreIndeks, siste);
    }
  }

  static <T> void skrivSegment(String ledetekst, T[] tab, int fom, int tom) {
    System.out.print(ledetekst + "[ ");
    for (int i = fom; i <= tom; i++)
      System.out.print(tab[i] + " ");
    System.out.println("]");
  }

  static String blanker(int antall) {
    StringBuilder blanke = new StringBuilder();
    for (int i = 0; i< 4*(antall-1); i++)
      blanke.append(' ');
    return blanke.toString();
  }
}